DECLARE SUB PromptVar ()
DECLARE SUB PromptComp ()
DECLARE SUB PromptCheck ()
DECLARE SUB MainLoop ()
DECLARE SUB ComputeObject (O$)
DECLARE SUB PromptD (Text$, Default$, TheString$)
DECLARE SUB MenuSettings ()
DECLARE SUB DrawSetWin ()
DECLARE SUB DrawObjectWin ()
DECLARE SUB PromptFilters (Filters$)
DECLARE SUB MenuFilters ()
DECLARE SUB Prompt (Text$, TheString$)
DECLARE SUB Init ()
DECLARE SUB GetFileName ()
DECLARE SUB SetFilterSequence ()
DECLARE FUNCTION IsSky% (strng$)
DECLARE SUB AbortErr (Err$)
DECLARE FUNCTION TestJohn% (Text$)
DECLARE FUNCTION MakeJohn$ (Text$)
DECLARE FUNCTION Object$ (Obj$)
DECLARE FUNCTION IsValidCatalog% (Text$)
DECLARE SUB WaitForKey (TheKey$)
DECLARE SUB DrawObjectStatus ()
DECLARE SUB DisplayObjectWin ()
DECLARE FUNCTION IsValidObject% (Name$)
DECLARE SUB DisplayTitle ()
DECLARE SUB DrawWindow (Dims!(), title$)
DECLARE SUB LocRel (Dims!(), Ry!, Rx!)
DECLARE FUNCTION IsFileName$ (Text$, Ext$)
DIM SHARED FiltWin(4), ObjectStatus(4), ObjectWin(4), SetWin(4)
COMMON SHARED VarStar$, CompStar$, CheckStar$, CurObject%, CurCatalogs%, IsDif%, FiltMode%, FileName$, Filters$, InComp%
'$DYNAMIC
DIM SHARED Objects$(100), FiltSeq$(0)

TYPE Sets
     FilterSeq AS STRING * 7
     VarStar   AS STRING * 12
     CheckStar AS STRING * 12
     CompStar  AS STRING * 12
END TYPE

DIM SHARED Settings AS Sets

FiltWin(1) = 20
FiltWin(2) = 15
FiltWin(3) = 61
FiltWin(4) = 20
CurBlock% = 1
CurObject% = 0

'OList generator for the SSP line of photometers
'v1.2

     COLOR 7
     CLS
     CALL Init
     CALL DisplayTitle
     CALL WaitForKey(temp$)
GetFile:
     CLS
     CALL GetFileName
     CALL MenuFilters
     CALL MenuSettings
     CALL MainLoop
     PRINT "jtF - v1.2"

END

BadFile:
     PRINT "Error writing to file.  Press any key to continue..."
     CALL WaitForKey(temp$)
     RESUME GetFile:

REM $STATIC
'This sub aborts safely with a programmer-specified error
SUB AbortErr (Err$)

     VIEW PRINT
     COLOR 7, 0
     CLS
     PRINT "Critical error in execution:"
     PRINT Err$
     CLOSE

END SUB

' This sub does all the calculations necessary when a new object is entered
' by the user.
'
SUB ComputeObject (O$)
        
'First convert the object abbreviation to the object name  
     O$ = Object$(UCASE$(O$))
   
'Increment the Current Object counter
     CurObject% = CurObject% + 1
   
'Add the object to the Objects$ array
     Objects$(CurObject%) = O$
    
'Figger out the catalogs  
     IF IsDif% THEN
          SELECT CASE O$
               CASE Settings.VarStar
                    IF InComp% THEN
                         CurCatalogs$ = CurCatalogs$ + "V"
                    ELSE
                         PromptForCatalog% = 1
                    END IF
               CASE Settings.CompStar, Settings.CheckStar
                    IF InComp% THEN
                         CurCatalogs$ = CurCatalogs$ + "C"
                    ELSE
                         PromptForCatalog% = 1
                    END IF
               CASE ELSE
                    CurCatalogs$ = CurCatalogs$ + " "
          END SELECT
                   
          IF PromptForCatalog% = 1 THEN 'If they weren't in COMP.CAT...
               RefObj% = 0
               FOR I% = 1 TO CurObject% - 1
                    IF INSTR(Objects$(I%), O$) <> 0 THEN
                         RefObj% = I%
                    END IF
               NEXT I%
             
               DO
                    IF RefObj% > 0 THEN
                         DCat$ = MID$(CurCatalogs$, RefObj%, 1)
                         CALL PromptD("Catalog [" + DCat$ + "]:  ", DCat$, NextCat$)
                    ELSE
                         CALL Prompt("Catalog:  ", NextCat$)
                    END IF

                    IF IsValidCatalog%(NextCat$) THEN
                         CurCatalogs$ = CurCatalogs$ + UCASE$(LEFT$(NextCat$, 1))
                         GotOne% = 1
                    ELSE
                         PRINT "Catalog must be A, F, S, C, V, or M."
                    END IF
               LOOP UNTIL GotOne% = 1
          END IF
    
     ELSE      'Not a differential
          IF IsSky%(O$) = 0 THEN
               RefObj% = 0
               FOR I% = 1 TO CurObject% - 1
                    IF INSTR(Objects$(I%), O$) <> 0 THEN
                         RefObj% = I%
                    END IF
               NEXT I%
              
               DO
                    IF RefObj% > 0 THEN
                         DCat$ = MID$(CurCatalogs$, RefObj%, 1)
                         CALL PromptD("Catalog [" + DCat$ + "]:  ", DCat$, NextCat$)
                    ELSE
                         CALL Prompt("Catalog:  ", NextCat$)
                    END IF

                    IF IsValidCatalog%(NextCat$) THEN
                         CurCatalogs$ = CurCatalogs$ + UCASE$(LEFT$(NextCat$, 1))
                         GotOne% = 1
                    ELSE
                         PRINT "Catalog must be A, F, S, C, V, or M."
                    END IF
               LOOP UNTIL GotOne% = 1
          ELSE
               CurCatalogs$ = CurCatalogs$ + " "
          END IF
     END IF

END SUB

'This displays the title window.
SUB DisplayTitle

     DIM title(4)
     title(1) = 10
     title(2) = 5
     title(3) = 70
     title(4) = 20
     DrawWindow title(), "ListGen"

     LocRel title(), 2, 4
     PRINT "* The OList Generator for the SSP control software *"
     LocRel title(), 4, 25
     PRINT "Optec Inc."
     LocRel title(), 5, 22
     PRINT "199 Smith Street"
     LocRel title(), 6, 22
     PRINT "Lowell, MI 49331"
     LocRel title(), 7, 27
     PRINT "U.S.A."
     LocRel title(), 9, 11
     PRINT "(616) 897-9351  -  FAX:  (616) 897-8229"
     LocRel title(), 11, 15
     PRINT "E-Mail:  OptecInc@aol.com"
     LocRel title(), 12, 13
     PRINT "Web Site:  http://www.optecinc.com"

     LOCATE 24, 28
     PRINT "Press any key to continue"

END SUB

'This draws/updates the "Block Status" window which shows the user the last
'six objects in the current block
'
SUB DrawObjectStatus

     ObjectStatus(1) = 60
     ObjectStatus(2) = 16
     ObjectStatus(3) = 80
     ObjectStatus(4) = 24
     cntr% = 0

     CALL DrawWindow(ObjectStatus(), "Block Status")
     LocRel ObjectStatus(), 1, 1
     IF CurObject% = 0 THEN EXIT SUB
     J% = 23 - CurObject%
     IF J% < 17 THEN J% = 17
     FOR I% = 23 TO J% STEP -1
          LOCATE I%, 61
          PRINT Objects$(CurObject% - cntr%)
          cntr% = cntr% + 1
     NEXT I%

END SUB

'This just displays the appropriate help window for object entry.
'
SUB DrawObjectWin
    
IF IsDif% THEN
     ObjectWin(1) = 2
     ObjectWin(2) = 1
     ObjectWin(3) = 79
     ObjectWin(4) = 14
     DrawWindow ObjectWin(), "Object Entry"
     LocRel ObjectWin(), 1, 5
     PRINT "At the `Next Object:>' prompt, you may input any of the following:"
     LocRel ObjectWin(), 3, 20
     PRINT "V: " + Settings.VarStar
     LocRel ObjectWin(), 4, 20
     PRINT "C: " + Settings.CompStar
     LocRel ObjectWin(), 5, 20
     PRINT "K: " + Settings.CheckStar
     LocRel ObjectWin(), 6, 20
     PRINT "N: SkyNEXT"
     LocRel ObjectWin(), 7, 20
     PRINT "S: SKY"
     LocRel ObjectWin(), 8, 20
     PRINT "L: SkyLAST"
     LocRel ObjectWin(), 9, 20
     PRINT "FIX: Change the previous object"
     LocRel ObjectWin(), 10, 20
     PRINT "STOP: Terminate current block"
     LocRel ObjectWin(), 11, 20
     PRINT "END: Terminate current OList"
ELSE
     ObjectWin(1) = 2
     ObjectWin(2) = 3
     ObjectWin(3) = 79
     ObjectWin(4) = 14
     DrawWindow ObjectWin(), "Object Entry"
     LocRel ObjectWin(), 1, 10
     PRINT "At the `Next Object:>' prompt, you may input a star name"
     LocRel ObjectWin(), 2, 25
     PRINT "or any of the following:"
     LocRel ObjectWin(), 4, 20
     PRINT "N: SkyNEXT"
     LocRel ObjectWin(), 5, 20
     PRINT "S: SKY"
     LocRel ObjectWin(), 6, 20
     PRINT "L: SkyLAST"
     LocRel ObjectWin(), 7, 20
     PRINT "FIX: Change the previous object"
     LocRel ObjectWin(), 8, 20
     PRINT "STOP: Terminate current block"
     LocRel ObjectWin(), 9, 20
     PRINT "END: Terminate current OList"
END IF

END SUB

SUB DrawSetWin

     SetWin(1) = 1
     SetWin(2) = 1
     SetWin(3) = 80
     SetWin(4) = 8
     CALL DrawWindow(SetWin(), "Current Settings")
     LOCATE 2, 8: PRINT "Filter Sequence:  " + Settings.FilterSeq
     LOCATE 3, 5: PRINT "Variable Star Name:  " + Settings.VarStar
     LOCATE 4, 3: PRINT "Comparison Star Name:  " + Settings.CompStar
     LOCATE 5, 8: PRINT "Check Star Name:  " + Settings.CheckStar

END SUB

'This universally handy utility draws a window with border coordinates
'specified in a four-dimensional array (Dims()) and with Title$ centred at
'the top of the frame.
'
SUB DrawWindow (Dims(), title$)

     FOR I% = Dims(1) TO Dims(3)
          FOR J% = Dims(2) TO Dims(4)
               LOCATE J%, I%
               PRINT " "
          NEXT J%
     NEXT I%

     FOR I% = Dims(1) TO Dims(3)
          LOCATE Dims(2), I%
          PRINT CHR$(205)
     NEXT I%

     FOR I% = Dims(1) TO Dims(3)
          LOCATE Dims(4), I%
          PRINT CHR$(205)
     NEXT I%

     FOR I% = Dims(2) TO Dims(4)
          LOCATE I%, Dims(1)
          PRINT CHR$(186)
     NEXT I%

     FOR I% = Dims(2) TO Dims(4)
          LOCATE I%, Dims(3)
          PRINT CHR$(186)
     NEXT I%

     LOCATE Dims(2), Dims(1)
     PRINT CHR$(201)
     LOCATE Dims(4), Dims(1)
     PRINT CHR$(200)
     LOCATE Dims(2), Dims(3)
     PRINT CHR$(187)
     LOCATE Dims(4), Dims(3)
     PRINT CHR$(188)
    

     LOCATE Dims(2), (Dims(1) + (Dims(3) - Dims(1)) / 2 - (LEN(title$) + 4) / 2)
     PRINT CHR$(181); " "; title$; " "; CHR$(198)
    
END SUB

SUB GetFileName
   
     CALL Prompt("OList File Name:  ", FileName$)
     IF FileName$ = "" THEN FileName$ = "DEFAULT.OLS"
     PRINT "File " + FileName$ + " opened."
ON ERROR GOTO BadFile:   
     OPEN FileName$ FOR OUTPUT AS #1
     PRINT #1, "FILE="; FileName$; "     ;USED AS SCHEDULE FOR OBJECTS"
     PRINT #1, "CAT OBJECT     FLT"
ON ERROR GOTO 0

END SUB

'This just reads the one readable line in the config file which tells which
'kind of photometry this olist will be used for.
'
SUB Init
    
     OPEN "listgen.cfg" FOR INPUT AS #2
          cntr = 1
          FiltMode% = 0
          DO UNTIL FiltMode% <> 0
               LINE INPUT #2, temp$
               IF LEFT$(temp$, 1) <> "*" THEN
                    SELECT CASE UCASE$(LEFT$(temp$, 1))
                         CASE "J"
                              FiltMode% = 1
                         CASE "S"
                              FiltMode% = 2
                         CASE ELSE
                              CALL AbortErr("Invalid line in LISTGEN.CFG " + CHR$(13) + temp$ + CHR$(13) + " should be JOHNSON or STANDARD.")
                   END SELECT
               END IF
          LOOP

END SUB

FUNCTION IsSky% (strng$)

IsSky% = 0
IF strng$ = "SKYNEXT" THEN IsSky% = 1
IF strng$ = "SKYLAST" THEN IsSky% = 1
IF strng$ = "SKY" THEN IsSky% = 1

END FUNCTION

'This function just checks to make sure the first letter of a string is a
'valid catalog name
'
FUNCTION IsValidCatalog% (Text$)

     IF UCASE$(LEFT$(Text$, 1)) = "A" THEN IsValidCatalog% = 1
     IF UCASE$(LEFT$(Text$, 1)) = "F" THEN IsValidCatalog% = 1
     IF UCASE$(LEFT$(Text$, 1)) = "S" THEN IsValidCatalog% = 1
     IF UCASE$(LEFT$(Text$, 1)) = "C" THEN IsValidCatalog% = 1
     IF UCASE$(LEFT$(Text$, 1)) = "V" THEN IsValidCatalog% = 1
     IF UCASE$(LEFT$(Text$, 1)) = "M" THEN IsValidCatalog% = 1

END FUNCTION

'This function tests to see if text is a valid object name abbreviation
'(V,C,K,N,S, or L)
'
FUNCTION IsValidObject% (Name$)

     IF IsDif% = 0 THEN  'If this is not a differential, all objects are valid
          IsValidObject% = 1
     ELSE
          Name$ = LEFT$(UCASE$(Name$), 1)
          IF Name$ = "V" THEN IsValidObject% = 1
          IF Name$ = "C" THEN IsValidObject% = 1
          IF Name$ = "K" THEN IsValidObject% = 1
          IF Name$ = "N" THEN IsValidObject% = 1
          IF Name$ = "S" THEN IsValidObject% = 1
          IF Name$ = "L" THEN IsValidObject% = 1
     END IF

END FUNCTION

'This sub goes along with the DrawWindow sub to locate the cursor at a
'position relative to the borders of the specified window.  Some error-checking
'could be implemented here to prevent placing the cursor beyond the current
'borders, etc, but we libertarians always opt for freedom over safety.
'
SUB LocRel (Dims(), Ry, Rx)

     LOCATE Dims(2) + Ry, Dims(1) + Rx

END SUB

'This is the main Object-name-retrieving loop for the whole program.  The bulk
'of the work is done here; however, it may be better to break this down into
'smaller subs.
'
SUB MainLoop

DO
     CLS
     Ender% = 0
     Stopper% = 0
     CALL DrawObjectWin
     VIEW PRINT 16 TO 25
     DO
          CLS
          CALL DrawObjectStatus
          VIEW PRINT 16 TO 25
          LOCATE 16, 1
          CALL Prompt("Next Object:>  ", NextObj$)
          SELECT CASE UCASE$(NextObj$)
               CASE "STOP"
                    Stopper% = 1
                    EXIT DO
              
               CASE "END"
                    Ender% = 1
                    EXIT DO
              
               CASE "FIX"
                    IF CurObject% > 0 THEN
                         CurObject% = CurObject% - 1
                         CurCatalogs$ = LEFT$(CurCatalogs$, LEN(CurCatalogs$) - 1)
                    ELSE
                         PRINT "You have not entered an Object yet!"
                         WaitForKey t$
                    END IF
        
               CASE ""
                    IF CurObject% > 0 THEN NextObj$ = Objects$(CurObject% - 1)
              
               CASE ELSE
                    IF IsValidObject%(UCASE$(NextObj$)) THEN CALL ComputeObject(NextObj$)

          END SELECT
     LOOP UNTIL Stopper% OR Ender%

     IF CurObject% <> LEN(CurCatalogs$) THEN
          PRINT "Catalogs unequal to Objects!  ("; STR$(CurObject%); ")("; CurCatalogs$; ")"
          END
     END IF
     FOR I% = 1 TO CurObject%
          FOR J% = 1 TO LEN(Filters$)
               DataLine$ = " " + MID$(CurCatalogs$, I%, 1) + " " + LEFT$(Objects$(I%) + "          ", 10) + "   " + MID$(Settings.FilterSeq, J%, 1)
               PRINT #1, DataLine$
          NEXT J%
     NEXT I%
   
     VIEW PRINT 1 TO 25

     IF Stopper% THEN
          CLS
          CurObject% = 0
          CurCatalogs$ = ""
          CLS
          PRINT "New Block"
          CALL MenuFilters
          CALL MenuSettings
     END IF
     IF Ender% THEN EXIT DO

LOOP

     CLOSE #1
     CLS

END SUB

'This function converts Text$ to a valid Johnson filter sequence.
'
FUNCTION MakeJohn$ (Text$)

     IF TestJohn%(Text$) = 1 THEN EXIT FUNCTION
     IF RIGHT$(Text$, 1) = "C" THEN Text$ = LEFT$(Text$, LEN(Text$) - 1)
     IF Text$ = "" THEN Text$ = "UBVRI"
     SELECT CASE LEN(Text$)
     CASE 2
          IF LEFT$(Text$, 1) = "U" THEN Text$ = "UB"
          IF LEFT$(Text$, 1) = "B" THEN Text$ = "BV"
          IF LEFT$(Text$, 1) = "V" THEN Text$ = "VR"
          IF LEFT$(Text$, 1) = "R" THEN Text$ = "VR"
          IF LEFT$(Text$, 1) = "I" THEN Text$ = "VI"
     CASE 3
          IF LEFT$(Text$, 1) = "U" THEN Text$ = "UBV"
          IF LEFT$(Text$, 1) = "B" THEN Text$ = "BVR"
          IF LEFT$(Text$, 1) = "V" THEN Text$ = "BVR"
          IF LEFT$(Text$, 1) = "R" THEN Text$ = "BVR"
          IF LEFT$(Text$, 1) = "I" THEN Text$ = "BVI"
     CASE 4
          IF LEFT$(Text$, 1) = "U" THEN Text$ = "UBVR"
          IF LEFT$(Text$, 1) = "B" THEN Text$ = "BVRI"
          IF LEFT$(Text$, 1) = "V" THEN Text$ = "BVRI"
          IF LEFT$(Text$, 1) = "R" THEN Text$ = "BVRI"
          IF LEFT$(Text$, 1) = "I" THEN Text$ = "UBVI"
     CASE 5
          Text$ = "UBVRI"
     END SELECT

     MakeJohn$ = Text$
END FUNCTION

SUB MenuFilters

     DO
          CALL PromptFilters(Filters$)
          IF LEN(Filters$) = 0 THEN
               PRINT "That was an invalid filter sequence!"
          ELSE
               PRINT "Your filter sequence is "; Filters$
               PRINT "Is this okay? <[Y]/N>"
               CALL WaitForKey(temp$)
               IF UCASE$(temp$) = "N" THEN CLS  ELSE EXIT DO
          END IF
    
          IF FiltMode% = 1 THEN
               IF TestJohn%(Filters$) = 0 THEN
                    Filters$ = MakeJohn$(Filters$)
                    PRINT "You did not input a vaild Johnson filter sequence."
                    PRINT "Your filter sequence has been converted to "; Filters$
                    PRINT "Is this okay? <Y/[N]>"
                    CALL WaitForKey(temp$)
                    IF UCASE$(temp$) = "Y" THEN EXIT DO
               END IF
          END IF
     LOOP

END SUB

SUB MenuSettings
    
     CALL Prompt("Is this a differential photometry block <[Y]/N>?  ", temp$)
     CLS
     IF UCASE$(LEFT$(temp$, 1)) = "N" THEN IsDif% = 0 ELSE IsDif% = 1
     IF IsDif% THEN
          CALL DrawSetWin
          LOCATE 9, 1
          CALL Prompt("Are your comparison and check stars both in COMP.CAT <[Y]/N>?  ", temp$)
          IF UCASE$(LEFT$(temp$, 1)) = "N" THEN InComp% = 0 ELSE InComp% = 1
          LOCATE 9, 1: PRINT SPACE$(70)
          CALL PromptVar
          CALL DrawSetWin
          LOCATE 9, 1: PRINT SPACE$(70)
          CALL PromptComp
          CALL DrawSetWin
          LOCATE 9, 1: PRINT SPACE$(70)
          CALL PromptCheck
          CALL DrawSetWin
     END IF

END SUB

'This function converts the object abbreviation used in block editing to a
'valid object name to be output to the OList
'
FUNCTION Object$ (Obj$)

     IF Obj$ = "V" AND IsDif% THEN Object$ = Settings.VarStar
     IF Obj$ = "C" AND IsDif% THEN Object$ = Settings.CompStar
     IF Obj$ = "K" AND IsDif% THEN Object$ = Settings.CheckStar
     IF Obj$ = "N" THEN
          Object$ = "SKYNEXT"
          ISky% = 1
     END IF
     IF Obj$ = "S" THEN
          Object$ = "SKY"
          ISky% = 1
     END IF
     IF Obj$ = "L" THEN
          Object$ = "SKYLAST"
          ISky% = 1
     END IF
     IF IsDif% = 0 AND ISky% = 0 THEN Object$ = Obj$

END FUNCTION

'This is the main data input routine for the program.  It's basically a
'cleaner way to get data than, say, the INPUT statement.
'
SUB Prompt (Text$, TheString$)

     TheString$ = ""
     StartPosY% = CSRLIN
     StartPosX% = LEN(Text$) + 1
     PRINT Text$;
     COLOR 23
     PRINT "_ ";
     COLOR 7

     DO
          DO
               Char$ = INKEY$
          LOOP UNTIL Char$ <> ""

          SELECT CASE ASC(Char$)
               CASE 8    'A backspace
                    IF LEN(TheString$) > 0 THEN
                         TheString$ = LEFT$(TheString$, LEN(TheString$) - 1)
                    END IF
               CASE 13   'Carriage return
                    Endit% = 1
               CASE ELSE
                    TheString$ = TheString$ + Char$
          END SELECT

          IF StartPosX% + LEN(TheString$) > 79 THEN TheString$ = LEFT$(TheString$, 79 - StartPosX%)
          LOCATE StartPosY%, StartPosX%
          PRINT TheString$;
          COLOR 23
          PRINT "_ ";
          COLOR 7

     LOOP UNTIL Endit% = 1

     LOCATE StartPosY%, StartPosX% + LEN(TheString$)
     PRINT " "
END SUB

SUB PromptCheck
         
     LOCATE 9, 1
     CALL Prompt("Check star:  ", CheckStar$)
     Settings.CheckStar = LEFT$(CheckStar$ + "            ", 12)

END SUB

SUB PromptComp
         
          LOCATE 9, 1
          CALL Prompt("Comparison star:  ", CompStar$)
          Settings.CompStar = LEFT$(CompStar$ + "            ", 12)
END SUB

'This is exactly the same as the Prompt statement, but with a default option.
'
SUB PromptD (Text$, Default$, TheString$)

     TheString$ = ""
     StartPosY% = CSRLIN
     StartPosX% = LEN(Text$) + 1
     PRINT Text$;

     DO
          DO
               Char$ = INKEY$
          LOOP UNTIL Char$ <> ""

          SELECT CASE ASC(Char$)
               CASE 8    'A backspace
                    IF LEN(TheString$) > 0 THEN
                         TheString$ = LEFT$(TheString$, LEN(TheString$) - 1)
                    END IF
               CASE 13   'Carriage return
                    Endit% = 1
               CASE ELSE
                    TheString$ = TheString$ + Char$
          END SELECT

          IF StartPosX% + LEN(TheString$) > 79 THEN TheString$ = LEFT$(TheString$, 79 - StartPosX%)
          LOCATE StartPosY%, StartPosX%
          PRINT TheString$;
          COLOR 23
          PRINT "_ ";
          COLOR 7

     LOOP UNTIL Endit% = 1

     LOCATE StartPosY%, StartPosX% + LEN(TheString$)
     PRINT " "

     IF TheString$ = "" THEN TheString$ = Default$

END SUB

'This sub tries to inteligently (?!) translate anything that the user inputs
'into a valid filter sequence.
'
SUB PromptFilters (Filters$)

     U% = 0
     B% = 0
     V% = 0
     R% = 0
     I% = 0
     C% = 0
     Filters$ = ""
     DrawWindow FiltWin(), "Filter Sequence"
     IF FiltMode% = 1 THEN
          LocRel FiltWin(), 1, 2
          PRINT "Filter sequences must be in the order:"
          LocRel FiltWin(), 2, 12
          PRINT "U - B - V - R - I"
          LocRel FiltWin(), 4, 2
          PRINT "Ex: VR, UBV, BVRI, UBVRIC, etc."
     END IF
     IF FiltMode% = 2 THEN
          LocRel FiltWin(), 1, 2
          PRINT "Filter sequences may be in ANY order."
          LocRel FiltWin(), 2, 2
          PRINT "No error checking will be performed on filter sequences."
     END IF

     LOCATE 3, 1
     CALL Prompt("Filter sequence to use:  ", temp$)
     FOR t% = 1 TO LEN(temp$)
          IF UCASE$(MID$(temp$, t%, 1)) = "U" THEN U% = 1
          IF UCASE$(MID$(temp$, t%, 1)) = "B" THEN B% = 1
          IF UCASE$(MID$(temp$, t%, 1)) = "V" THEN V% = 1
          IF UCASE$(MID$(temp$, t%, 1)) = "R" THEN R% = 1
          IF UCASE$(MID$(temp$, t%, 1)) = "I" THEN I% = 1
          IF UCASE$(MID$(temp$, t%, 1)) = "C" THEN C% = 1
     NEXT t%
     IF U% = 1 THEN Filters$ = "U"
     IF B% = 1 THEN Filters$ = Filters$ + "B"
     IF V% = 1 THEN Filters$ = Filters$ + "V"
     IF R% = 1 THEN Filters$ = Filters$ + "R"
     IF I% = 1 THEN Filters$ = Filters$ + "I"
     IF C% = 1 THEN Filters$ = Filters$ + "C"

     Settings.FilterSeq = Filters$

END SUB

SUB PromptVar
     LOCATE 9, 1
     CALL Prompt("Variable star:  ", VarStar$)
     Settings.VarStar = LEFT$(VarStar$ + "            ", 12)
END SUB

SUB SetFilters (Filters$)
    
     REDIM FiltSeq$(LEN(Filters$))

     FOR t% = 1 TO LEN(Filters$)
          FiltSeq$(t%) = MID$(Filters$, t%, 1)
     NEXT t%

END SUB

'This function returns a 1 if a string is a valid Johnson filter sequence
'
FUNCTION TestJohn% (Text$)

     TestJohn% = 0
     IF Text$ = "UB" THEN TestJohn% = 1
     IF Text$ = "BV" THEN TestJohn% = 1
     IF Text$ = "VR" THEN TestJohn% = 1
     IF Text$ = "VI" THEN TestJohn% = 1
     IF Text$ = "UBV" THEN TestJohn% = 1
     IF Text$ = "BVR" THEN TestJohn% = 1
     IF Text$ = "BVI" THEN TestJohn% = 1
     IF Text$ = "UBVR" THEN TestJohn% = 1
     IF Text$ = "UBVI" THEN TestJohn% = 1
     IF Text$ = "BVRI" THEN TestJohn% = 1
     IF Text$ = "UBVRI" THEN TestJohn% = 1

END FUNCTION

'This just pauses until the user presses a key, then returns the key
'
SUB WaitForKey (TheKey$)

     DO
          TheKey$ = INKEY$
     LOOP UNTIL TheKey$ <> ""

END SUB

