DECLARE SUB QBMouse (a!, b!, c!, d!)
DECLARE FUNCTION AltPressed% ()
DECLARE FUNCTION KeyReady! ()
DECLARE FUNCTION GetKey$ ()
DECLARE FUNCTION MouseInMenu% ()
DIM SHARED NextKey$

'

'*********************************************************************
'*   This function returns a true value if either alt key is pressed,
'*   and a false otherwise.  It's used only for the pulldown menus,
'*   but could also be used with hot keys (would take some work.)
'*
'*********************************************************************
'
FUNCTION AltPressed%

     DEF SEG = &H40
     X = PEEK(&H17)
     DEF SEG

     IF X AND 8 THEN
          AltPressed% = 1
     ELSE
          AltPressed% = 0
     END IF

END FUNCTION '

'*********************************************************************
'*   This function returns the last key pressed, or if no key is in the
'*   buffer waits for the user to press a key.
'*
'*
'*********************************************************************
'
FUNCTION GetKey$

     IF NextKey$ <> "" THEN
          GetKey$ = LEFT$(NextKey$, 1)
     ELSE
          DO
          LOOP WHILE NOT KeyReady
          GetKey$ = NextKey$
     END IF

     IF LEN(NextKey$) > 1 THEN
          NextKey$ = RIGHT$(NextKey$, LEN(NextKey$) - 1)
     ELSE
          NextKey$ = ""
     END IF

END FUNCTION '

'*********************************************************************
'*   This function returns a TRUE value if a key has been pressed, and
'*   a false otherwise.  If a key was pressed, it is moved into the buffer.
'*
'*
'*********************************************************************
'
FUNCTION KeyReady

     NextKey$ = NextKey$ + INKEY$

     IF NextKey$ <> "" THEN
          KeyReady = 1
     ELSE
          KeyReady = 0
     END IF

END FUNCTION '

'***************************************************************************
'*   This subroutine should return a 1 if the mouse cursor is in the menu
'*   bar and a button is being pressed.
'*
'*
'***************************************************************************
'
FUNCTION MouseInMenu%
    
     QBMouse 3, b, mx, my
     mx = mx / 8 + 1: my = my / 8 + 1

     IF b = 1 AND my = 1 THEN
          MouseInMenu% = 1
     ELSE
          MouseInMenu% = 0
     END IF

END FUNCTION

